src/website/events/forms.py
from flask_wtf import FlaskForm
from wtforms import DateTimeField, StringField, FileField, SubmitField
from flask_wtf.file import FileField, FileAllowed, FileRequired
from wtforms.validators import InputRequired
from wtforms.widgets import TextArea

from datetime import datetime

class NovoEventoForm(FlaskForm):
    titulo = StringField('Title', validators=[InputRequired()])
    inicio = DateTimeField('Start', validators=[InputRequired()],
                                format = "%Y-%m-%dT%H:%M", default=datetime.utcnow)
    fim = DateTimeField('End', validators=[InputRequired()],
                                format = "%Y-%m-%dT%H:%M", default=datetime.utcnow)
    banner = FileField('Banner', validators=[FileRequired(),
                                            FileAllowed(['jpg', 'png'], 'Images only!')])
    descricao = StringField('Description', widget=TextArea(), validators=[InputRequired()])

    submit  = SubmitField('Create Event')

class EditaEventoForm(FlaskForm):
    titulo = StringField('Title', validators=[InputRequired()])
    descricao = StringField('Description', widget=TextArea(), validators=[InputRequired()])

    submit  = SubmitField('Edit Event')

src/website/events/__init__.py
from .blueprint import bp

src/website/events/blueprint.py
import os
from flask import render_template, Blueprint, request, redirect, url_for, current_app as app
from flask_login import login_required, current_user
from pymongo import MongoClient
from ..auth import group_required, belongs_to_group
from ..images import save_image, get as get_image

from uuid import uuid4, UUID
from datetime import datetime
from src.eventos_service import EventoCommandHandlers, EventoReadModel, EventoReadFacade
from src.eventos_service import CriarEvento, DefinirParametroEvento, PublicarEvento
from src.kernel.messages import MessageBuilder

from .forms import NovoEventoForm, EditaEventoForm

TIME_FORMAT = r'%Y-%m-%dT%H:%M'

db = MongoClient(os.environ.get('MONGO_URI2'))
EventoCommandHandlers.register(app.bus, app.store)
EventoReadModel.register(app.bus, db.eventos)
read = EventoReadFacade(db.eventos)
bp = Blueprint('events', __name__, template_folder='templates', url_prefix='/events')

@bp.route('/')
def eventslist():
    user = None if current_user.is_anonymous else UUID(int=current_user.id)
    eventos = read.eventos(criado_por=user, publicado=True)
    return render_template('events/list.html', eventos=eventos)

@bp.route('/manage')
@login_required
@group_required('admin', 'events_editor')
def dashboard():
    eventos = read.eventos(criado_por=UUID(int=current_user.id))
    return render_template('events/manage.html', eventos=eventos)

@bp.route('/new', methods=['GET', 'POST'])
@login_required
@group_required('admin', 'events_editor')
def new():
    form = NovoEventoForm()
    if form.validate_on_submit():
        model = request.form
        evento = uuid4()
        criado_por = UUID(int=current_user.id)
        inicio = datetime.strptime(model['inicio'], TIME_FORMAT)
        fim = datetime.strptime(model['fim'], TIME_FORMAT)

        titulo = model['titulo']
        descricao = model['descricao']
        banner = save_image(form.banner.data)

        criar = MessageBuilder() \
            .aggregate(evento, -1) \
            .type(CriarEvento) \
            .args(criado_por, inicio, fim)
        titulo = MessageBuilder() \
            .aggregate(evento, 0) \
            .type(DefinirParametroEvento) \
            .args('titulo', titulo)
        descricao = MessageBuilder() \
            .aggregate(evento, 1) \
            .type(DefinirParametroEvento) \
            .args('descricao', descricao)
        banner = MessageBuilder() \
            .aggregate(evento, 2) \
            .type(DefinirParametroEvento) \
            .args('banner', banner)
        app.bus.send(criar.build())
        app.bus.send(titulo.build())
        app.bus.send(descricao.build())
        app.bus.send(banner.build())

        return redirect(url_for('events.dashboard'))
    return render_template('events/new.html', form=form)

@bp.route('<evento_id>/<version>/publish', methods=['GET', 'POST'])
@login_required
@group_required('admin', 'events_editor')
def publish(evento_id, version):
    rq = MessageBuilder() \
            .aggregate(UUID(evento_id), int(version)) \
            .type(PublicarEvento)
    app.bus.send(rq.build())

    return redirect(url_for('events.dashboard'))

@bp.route('<evento_id>/<version>/edit', methods=['GET', 'POST'])
@login_required
@group_required('admin', 'events_editor')
def edit(evento_id, version):
    form = EditaEventoForm()

    evento = UUID(evento_id)
    args = read.evento(evento)

    form.titulo.data = args['titulo']
    form.descricao.data = args['descricao']

    if form.validate_on_submit():
        titulo = MessageBuilder() \
            .aggregate(evento, int(version)) \
            .type(DefinirParametroEvento) \
            .args('titulo', request.form['titulo'])
        descricao = MessageBuilder() \
            .aggregate(evento, (int(version) + 1)) \
            .type(DefinirParametroEvento) \
            .args('descricao', request.form['descricao'])

        app.bus.send(titulo.build())
        app.bus.send(descricao.build())
        return redirect(url_for('events.dashboard'))
    return render_template('events/edit.html', form=form)

src/website/events/templates/events/edit.html
{% extends 'dashboard/base.html' %}

{% block styles %}
  {{super()}}
  <style>
    .align-right {
      float: right;
    }
    .error {
      font-size: 14px;
      color: red;
    }
  </style>
{% endblock %}

{% block page_content %}
  <h5>Edit Event</h5>
  <form action="" method="POST" enctype="multipart/form-data">
    {{ form.hidden_tag() }}

    {{ form.titulo.label }} {{ form.titulo(class_="form-control") }}
    {% for error in form.titulo.errors %}
      <small class="error">{{error}}</small><br>
    {% endfor %}

    {{ form.descricao.label }} {{ form.descricao(class_="form-control", rows="15") }}
    {% for error in form.descricao.errors %}
      <small class="error">{{error}}</small><br>
    {% endfor %}
    {{ form.submit(class_="btn btn-success align-right") }}
  </form>

{% endblock %}

src/website/events/templates/events/list.html
{% extends 'public/base.html' %}

{% block page_content %}
<div class="container">
  <h2 class="hpage">Next Events</h2>
  <table class="table">
    <tbody>
      {% for event in eventos %}
        <tr>
          <td>
            <img src="{{url_for('images.show_image', iid=event.banner)}}" width="496px" height="279px"></td>
          <td>
            <p>{{event.titulo}}</p>
            {{event.descricao| markdown}}
          </td>
        </tr>
      {% endfor %}
    </tbody>
  </table>
</div>
{% endblock %}

src/website/events/templates/events/manage.html
{% extends 'dashboard/base.html' %}

{% block styles %}
  {{super()}}

{% endblock %}

{% block scripts %}
  {{super()}}
  <script src="{{ url_for('static', filename='js/jquery.dataTables.min.js') }}"></script>
  <script src="{{ url_for('static', filename='js/dataTables.bootstrap4.min.js') }}"></script>
  <script src="{{ url_for('static', filename='js/datatables.js') }}"></script>
  <script>
    var events = JSON.parse('{{eventos|tojson|replace("\\", "\\\\")}}')
    var event_to_delete = Object()
    function sendEventToDialog(id){
      let modal = $("#deleteEventModal")
      event_to_delete = events.find(function(e){
        return e.id == id
      })

      document.getElementById("deleteEventModalLabel").innerHTML = 'Do you want delete ' +
                                                                      event_to_delete.name +
                                                                      ' from events?';
      modal.modal()
    }

    $('#deleteForm').submit(function(eventObj) {
      $(this).append('<input type="hidden" name="event_id" value="'+event_to_delete.id+'">')
    })

  </script>
{% endblock %}

{% block page_content %}
  <div class="card shadow mb-4">
    <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
      <h6 class="m-0 font-weight-bold text-primary">Created Events</h6>
      <div class="dropdown no-arrow">
        <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
          data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
        </a>
        <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
          aria-labelledby="dropdownMenuLink">
          <div class="dropdown-header">Actions</div>
          <a class="dropdown-item" href="{{url_for('events.new')}}">New</a>
        </div>
      </div>
    </div>
    <div class="card-body">
      <div class="table-responsive">
        <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
          <thead>
            <tr>
              <th>Name</th>
              <th>Start</th>
              <th>End</th>
              <th></th>
            </tr>
          </thead>
          <tfoot>
            <tr>
              <th>Name</th>
              <th>Position</th>
              <th>Office</th>
              <th></th>
            </tr>
          </tfoot>
          <tbody>
            {% for evento in eventos %}
              <tr>
                <td>{{evento.titulo}}</td>
                <td>{{evento.starts}}</td>
                <td>{{evento.ends}}</td>
                <td>
                  <div class="row">

                    {% if not evento.publicado %}
                      <button
                        title="Corrigir"
                        style="background-color: transparent; border: none;"
                        onclick="window.location.href='./{{evento.id}}/{{evento.version}}/edit'">
                        <img width="24px" src="{{ url_for('static', filename='img/edit.png') }}">
                      </button>

                      <form action="./{{evento.id}}/{{evento.version}}/publish" method="POST">
                        <button class="btn btn-primary" type="submit">Publicar</button>
                      </form>
                    {% endif %}
                  </div>
                </td>
              </tr>
            {% endfor %}
          </tbody>
        </table>
      </div>
    </div>
  </div>
  <form id="deleteForm" action="./delete" method="POST">
    <div class="modal fade" id="deleteEventModal" tabindex="-1" role="dialog" aria-labelledby="deleteEventModalLabel" aria-hidden="true">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="deleteEventModalLabel"></h5>
            <button class="close" type="button" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">×</span>
            </button>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
            <input  class="btn btn-primary" style="color: #f8f9fc;" type="submit" value="Delete"></input>
          </div>
        </div>
      </div>
    </div>
  </form>
{% endblock %}

src/website/events/templates/events/new.html
{% extends 'dashboard/base.html' %}

{% block styles %}
  {{super()}}
  <style>
    .align-right {
      float: right;
    }
    .error {
      font-size: 14px;
      color: red;
    }
  </style>
{% endblock %}

{% block page_content %}
  <h5>New Event</h5>
  <form action="" method="POST" enctype="multipart/form-data">
    {{ form.hidden_tag() }}

    {{ form.titulo.label }} {{ form.titulo(class_="form-control") }}
    {% for error in form.titulo.errors %}
      <small class="error">{{error}}</small><br>
    {% endfor %}

    {{ form.inicio.label }} {{ form.inicio(class_="form-control", type="datetime-local") }}
    {% for error in form.inicio.errors %}
      <small class="error">{{error}}</small><br>
    {% endfor %}

    {{ form.fim.label }} {{ form.fim(class_="form-control", type="datetime-local") }}
    {% for error in form.fim.errors %}
      <small class="error">{{error}}</small><br>
    {% endfor %}

    {{ form.banner.label }} {{ form.banner(class_="form-control") }}
    {% for error in form.banner.errors %}
      <small class="error">{{error}}</small><br>
    {% endfor %}

    {{ form.descricao.label }} {{ form.descricao(class_="form-control", rows="15") }}
    {% for error in form.descricao.errors %}
      <small class="error">{{error}}</small><br>
    {% endfor %}
    {{ form.submit(class_="btn btn-success align-right") }}
  </form>

{% endblock %}